/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Don Aug  8 10:07:58 CEST 2002
    copyright            : (C) 2002 by Matt Rechenburg
    email                : mosixview@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>

#include "openmosixhistory.h"

int main(int argc, char *argv[])
{
  QApplication a(argc, argv);
  a.setFont(QFont("helvetica", 12));
  QTranslator tor( 0 );
  tor.load( QString("openmosixhistory.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );

	OpenMosixHistoryApp *openmosixhistory;

	if(argc==2) {
		openmosixhistory=new OpenMosixHistoryApp(argv[1]);
		} else {
		openmosixhistory=new OpenMosixHistoryApp(logdirectory);
	}

	a.setMainWidget(openmosixhistory);

	QFont font("helvetica");
	font.setPixelSize(12);
	openmosixhistory->setFont(font);
	openmosixhistory->setGeometry(600,220,500,480);
	openmosixhistory->resize(350, 420);
	openmosixhistory->show();
	return a.exec();
}


